#Davis Occurrence Matrix

#Written by Matt Davis matthew.davis@yale.edu
#Please acknowledge or cite where appropriate

#This is a function that will take an ordering of species labels from allrange and produce a therematrix that matches that order in terms of extinction

#it takes as input an alphabetically ordered alltaxa and then an vector with the new taxa ordering

#This corresponds to createtherematrix1.0 in the author's own version control system

createtherematrix <- function(alltaxa=alltaxa,taxonorder=taxonorder){
	
	taxonorder <- as.character(taxonorder)
	numbins <- length(alltaxa)
	
		
	#Generate a random therematrix
	#Make the occurence matrix
	therematrix <- matrix(data=0, nrow=numbins, ncol=numbins, dimnames=list(c(1:(numbins)),alltaxa))

	
	#Now fill it up
	for(i in 1:numbins){
		thistaxa <- taxonorder[i]
		
		therematrix[numbins:(numbins+1-i),thistaxa] <- 1
		
		}#End i loop
	
	#to check
	#apply(therematrix,1,sum)
	#head(therematrix)
	#tail(therematrix) 

	return(therematrix)
	
	
	
}#End function
