#Davis 2016 Timebinning

#Written by Matt Davis matthew.davis@yale.edu
#Please acknowledge or cite where appropriate

#This code will split up a base allrange set into a large dataframe with each species in each time bin. It includes two fake future bins and one fake bin with all the species in it. 

#This corresponds to timebinning1.3 in the author's own version control system

#######################################
#For 1,000 year time bins 

#Set new times for possible future extinctions
#Give a lad of -500 to those species that are near threatened
allrange[allrange$Red.List.status=="NT","LAD"] <- -500

#And give a lad of -1500 to those species that aren't threatened
allrange[allrange$Red.List.status=="DD"| allrange$Red.List.status=="LC","LAD"] <- -1500

#allrange





#Make the breaks for the bins you want
inoutdates <- seq(-2000,50000,by=1000)
timesteps <- length(inoutdates)

#Make the big list for all the different bins to go into
allrangelist <- list()

#Now fill up that list with all the species that are in that timebin

#First add a bin column
allrange$Bin <- NA

#And an age column even though they will be redundant
allrange$Age <- NA


#Now fill it up
#For each bin
for(i in 1:(timesteps-1)){
	
	#Take out only those taxa that occur in each bin.  Bin include younger edge but not older edge
	newrange<- allrange[allrange$FAD>=inoutdates[i] & allrange$LAD<inoutdates[i+1],]
	
	#Put in the bin and age numbers
	newrange$Bin <- i
	newrange$Age <- inoutdates[i]
	
	#Put it in the list
	allrangelist[[i]] <- newrange
	
	}#End i loop
	 
	 
#Now add in a bin 51 that includes all species
lastallrange <- allrange	 
lastallrange$Bin <- timesteps	
allrangelist[[timesteps]]	 <- lastallrange
	
	
allbin <- do.call("rbind",allrangelist)

#And check
head(allbin)	
tail(allbin)
dim(allbin)#3882 35	
class(allbin)#data.frame	
	
